%% Aufgabe 1

n=10000;
b=ones(n,1);
A=spdiags([-3.*b b 5.*b],[-7 0 3],n,n);
tic
x_A=A\b;
t_A=toc;

B=diag(b)-3.*diag(b(8:end),-7)+5.*diag(b(4:end),3);
tic
x_B=B\b;
t_B=toc

% isequal(A,B)

disp(['Die Berechnung ber die Sparse-Matrix bentigt ' num2str(t_A-t_B) ' Sekunden mehr'])

S=whos;

disp(['Die Berechnung ber die Sparse-Matrix bentigt ' num2str(S(2).bytes-S(1).bytes) ' Bytes weniger Arbeitsspeicher'])
disp(['Dies entspricht ' num2str(ceil((S(2).bytes-S(1).bytes)./1024)) ' KB'])
disp(['Dies entspricht ' num2str(ceil((S(2).bytes-S(1).bytes)./1024^2)) ' MB'])



%% Aufgabe 1 Nachtrag

n=1000;
m=10^2;
I=randi(n,m,3);
b=ones(n,1);
A=speye(n,n);
for i=1:length(I)
    A(I(i,1),I(i,2))=I(i,3);
end
spy(A)
tic
x_A=A\b;
t_A=toc;

B=eye(n);
for i=1:length(I)
    B(I(i,1),I(i,2))=I(i,3);
end
 isequal(A,B)

tic
x_B=B\b;
t_B=toc;

disp(['Die Berechnung ber die Sparse-Matrix bentigt ' num2str(t_A-t_B) ' Sekunden mehr'])

S=whos;

disp(['Die Berechnung ber die Sparse-Matrix bentigt ' num2str(S(2).bytes-S(1).bytes) ' Bytes weniger Arbeitsspeicher'])
disp(['Dies entspricht ' num2str(ceil((S(2).bytes-S(1).bytes)./1024)) ' KB'])
disp(['Dies entspricht ' num2str(ceil((S(2).bytes-S(1).bytes)./1024^2)) ' MB'])

%% Aufgabe 2

f=@(x) x^3- 10*x^2 + 31*x -30;

% Nullstellen sind 5, 3, 2

a=0;
b=5;
tol=1e-4;

[x,m]=Blatt7A2_nullstelle(f,a,b,tol);
disp(['Gefundene Nullstelle ist ' num2str(x)])

plot(m,1:length(m))
hold off
%% Aufgabe 3

k=9;
y=1:k;
y=2.^y;
x=zeros(k,2);
for i=4:k
    A=ones(y(i),y(i));
    tic 
    matrixmult(A,A);
    x(i,1)=toc;
    tic
    A*A;
    x(i,2)=toc;
end
x
hold on
plot(log(y),log(x(:,1)))
plot(log(y),log(x(:,2)))
hold off
legend('matrixmult','*')
xlabel('Dimension Testmatrix')
ylabel('Laufzeit')
title('Vergleich * mit matrixmult')

%% Aufgabe 4
n=100;
figure

subplot(1,2,1)

t=linspace(0,5*pi,n);
f=2+t;
polarplot(t,f)

subplot(1,2,2)

t=linspace(-pi,pi,n);
g=-sin(5.*t);
polarplot(t,g)

%% Aufgabe 5

%--> zeitmessung_loesung.m
%% 

%% Aufgabe 6
close all

f=@(x) sin(x);
g=@(x) cos(x);

h=@(x) cos(x)-sin(x);

% a)
figure
hold on
x=linspace(0,2*pi,100);
plot(x,f(x),'r-')
plot(x,g(x),'g.')
plot(x,h(x),'k--')
xlim([0, 2*pi])

% b)
figure
subplot(1,3,1)
plot(x,f(x),'r-')
xlim([0, 2*pi])

subplot(1,3,2)
plot(x,g(x),'g.')
xlim([0, 2*pi])

subplot(1,3,3)
plot(x,h(x),'k--')
xlim([0, 2*pi])

% c)
figure
subplot(2,2,1)
plot(x,f(x),'r-')
xlim([0, 2*pi])

subplot(2,2,2)
plot(x,g(x),'g.')
xlim([0, 2*pi])

subplot(2,2,[3 4])
plot(x,h(x),'k--')
xlim([0, 2*pi]+1)