% Aufgabe 1

disp('Aufgabe 1')
disp(' ')
disp('A+B+C=200')
disp('C-60=A-60+B-60')
disp('C-B=2*(B-A)')

A=[1 1 1;1 1 -1;2 -3 1];
b=[200;60;0];

x=A\b;

disp(['Andreas is ' num2str(x(1)) ', Burkhard ist ' num2str(x(2)) ' und Christian ist ' num2str(x(3)) ' Jahre alt'])
disp(' ')


% Aufgabe 2
disp('Aufgabe 2')
disp(' ')

% a)
v=[1 2 3 4];
w=[3 2 4 1];

v_t=v'
disp('v*w fhrt zu einer Fehlermeldung: Error using  * Inner matrix dimensions must agree.')
v_tw_t=v'*w
vw_t=v*w'
disp('v*w fhrt zu einer Fehlermeldung: Error using  * Inner matrix dimensions must agree.')
v_pw=v.*w
v_tpw=v'.*w
v_pw_t=v.*w'
v_tpw_t=v'.*w'
v_plus_w=v+w
v_t_plus_w=v'+w
v_plus_w_t=v+w'
v_t_plus_w_t=v'+w'


A=reshape(v,2,2);
disp('reshape(v,n,m) ordnet eine Matrix oder einen Vektor in eine n x m-Matrix um.')
disp('Dabei muss n*m der Anzahl der Elemente der Matrix oder des Vektors v sein.')
disp(' ')


% Aufgabe 3
disp('Aufgabe 3')
disp(' ')

A=[7 -2 1;-2 10 -2;1 -2 7];

% a)
disp(['Die Eigenwerte von A lauten:'])
lambda=eig(A)

% b)
ev_1=(A-diag([lambda(1) lambda(1) lambda(1)]))\[0;0;0]
disp('(A-diag(lambda)) \ 0 liefert nur die Triviale Lsung. Nutzen Sie auch hier eig.')

[EV,EW]=eig(A);
disp('Die Eigenvektoren lauten:')
disp(EV)

% c)
inv_A=A\[1 0 0;0 1 0;0 0 1]
inv_A=inv(A)
disp('Ja, die Inverse lautet:')
inv_A
inv_AA=inv_A*A

B=A^3+3*A^2+2*A;
C=A.^3+3*A.^2+2*A;

inv_B=inv(B)
inv_B*B
inv_C=inv(C)
inv_C*C
disp('B und C sind invertierbar.')
disp(' ')


% Aufgabe 4
disp('Aufgabe 4')
disp(' ')

% a)
A=[ 2 -1  0  0  0;...
   -1  2 -1  0  0;...
    0 -1  2 -1  0;...
    0  0 -1  2 -1;...
    0  0  0 -1  2]

b=[1 0 1 0 1]

x=A\b'

% b)

A=2*diag(ones(1,1000))-diag(ones(1,999),1)-diag(ones(1,999),-1);

disp(' ')


% Aufgabe 5
disp('Aufgabe 5')
disp(' ')

A=[ 3 -7  5 -1;...
    4  4 -3  0;...
   -9  8  1 -2;...
    0  2  3  1];

b=[39;-19;-26;14];
 

D=diag(diag(A))

L=tril(A)-D

R=triu(A)-D

x=A\b;

Lx=L*x
Dx=D*x
Rx=R*x

disp(' ')


% Aufgabe 6
disp('Aufgabe 6')
disp(' ')

% a)
load('Blatt2_matrix_A.mat')

% b)
determinante=0;
% Entwicklung fr i=j=1
% x  x x
%    _ _
% x |x x|
% x |x x|
%    _ _
determinante=             (-1)^(1+1)  *A(1,1)  *(A(2,2)*A(3,3)-A(2,3)*A(3,2));
% Entwicklung fr i=1, j=2
%  x  x x
%  _   _
% |x|x|x|
% |x|x|x|
%  _   _
determinante=determinante+(-1)^(1+2)  *A(1,2)  *(A(2,1)*A(3,3)-A(2,3)*A(3,1));
% Entwicklung fr i=1, j=3
% x  x x
%  _ _
% |x x|x
% |x x|x
%  _ _
determinante=determinante+(-1)^(1+3)  *A(1,3)  *(A(2,1)*A(3,2)-A(2,2)*A(3,1))

% c)

save('determinante.mat','A','determinante')

