%% Aufgabe 1

% a)
close all

n=100;
[x,y]=ndgrid(linspace(-1,1,n),linspace(-1,1,n));

f=@(x,y) 9-x.^2-y.^2;

figure
mesh(x,y,f(x,y))

figure
surf(x,y,f(x,y))

figure
surf(x,y,f(x,y),'EdgeColor','None')

figure
surfc(x,y,f(x,y),'EdgeColor','None')

figure
surface(x,y,f(x,y),'EdgeColor','None')

% b)

g=@(x,y) sin(x.*y);
h=@(x,y) cos(x+y)-2;

figure
hold on
surf(x,y,g(x,y),'EdgeColor','None')
surf(x,y,h(x,y),'EdgeColor','None')
hold off
view(3)

figure
hold on
surf(x,y,g(x,y),'EdgeColor','None','FaceAlpha',0.5)
surf(x,y,h(x,y),'EdgeColor','None')
hold off
view(3)

%% Aufgabe 2
close all

% a)
n=100;
[x,y,z]=peaks(n);

figure
surf(x,y,z)
c=colorbar;
c.Label.String = 'Color';
axis tight

xlabel('x')
ylabel('y')
zlabel('z')

title('Peaks-Funktion')

% b)
colormap('jet')
xlim([0 3])

% c)
n=100;
[x,y,z]=peaks(n);

C=@(x,y) cos(x./(2*pi)).*sin(y./(2*pi));

figure
surf(x,y,z,C(x,y))
c=colorbar;
c.Label.String = 'C(x,y)';
axis tight

xlabel('x')
ylabel('y')
zlabel('Peaks-Funktion')

title('Gefrbte Peaks-Funktion')

% d)
view(0,90)

%% Aufgabe 3

loadEarth

[Xk,Yk,Zk]=sph2cart(Y./360.*2*pi,X./360.*2*pi,ones(size(X)));

surf(Xk,Yk,Zk,earthsw,'EdgeColor','none')
axis equal
colormap('parula')

%% Aufgabe 4
close all
n=500;

[x,y]=ndgrid(linspace(-3,3,n),linspace(-3,3,n));

f=@(x,y) cos(x.*y)-sin(3.*x)+cos(2.*y);

figure
contourf(x,y,f(x,y),15)
colorbar

figure
surface(x,y,f(x,y),'EdgeColor','None')
colorbar
axis tight

%%
Blatt8A5_Haus

